from gensim.models.coherencemodel import CoherenceModel
from gensim.corpora import Dictionary

import sys

def getScore(path,docs,corpus,dictionary,metric='u_mass'):
    with open(path) as f:data=f.read().split('\n')
    topics=[topic.split('\t')[:-1] for topic in data if len(topic)]
    # print('n_topics:{}, top_words:{}'.format(len(topics),len(topics[0])))
    cm = CoherenceModel(topics=topics,texts=docs, corpus=corpus, dictionary=dictionary, coherence=metric)
    coherence = cm.get_coherence()  # get coherence value
    print('{}:{}'.format(metric,coherence))

def get_data(corpus, aft):
    path_name = './corpus_data/'

    doc_ids = []
    text_name = path_name + 'doc_ids_{}.txt'.format(corpus)
    with open(text_name, 'r') as f:
        for line in f:
            line = line.strip().split()
            line = list(map(int, line))
            doc_ids.append(line)

    doc_cnt = []
    text_name = path_name + 'doc_cnt_{}.txt'.format(corpus)
    with open(text_name, 'r') as f:
        for line in f:
            line = line.strip().split()
            line = list(map(int, line))
            doc_cnt.append(line)

    index2word = {}
    voca = []
    text_name = path_name + 'index2word_{}.txt'.format(corpus)
    with open(text_name, 'r') as f:
        for line in f:
            line = line.strip().split('\t')
            if len(line) == 1:
                voca.append('')
                continue
            ind, word = line[0], line[1]
            voca.append(word)
            index2word.update({ind : word})

    return doc_ids, doc_cnt, voca, index2word

def main():

    doc_ids, doc_cnt, voca, index2word = get_data('all', '_co')
    docs=[[index2word[str(i)]for i in doc]for doc in doc_ids]
    print('docs ok')
    dictionary = Dictionary(docs)
    corpus = [dictionary.doc2bow(doc) for doc in docs]
    print('corpus ok')
    path='output/lda/200all.txt'
    if len(sys.argv)>1:path=sys.argv[1]
    for metric in ['c_v','u_mass','c_uci']:getScore(path,docs,corpus,dictionary,metric=metric)

if __name__ == '__main__':
    main()