import json
from pprint import pprint
from collections import defaultdict


def get_json(data_name, data_mode):
    json_data = []

    if data_name == 'case' or data_name == 'both':
        text_name = './link_data/case_cocitationgraph_{}.json'.format(data_mode)
        print(text_name)
        with open(text_name, 'r') as f:
            json_data_kari = json.load(f)
            json_data.append(json_data_kari)
    if data_name == 'status' or data_name == 'both':
        text_name = './link_data/status_cocitationgraph_{}.json'.format(data_mode)
        print(text_name)
        with open(text_name, 'r') as f:
            json_data_kari = json.load(f)
            json_data.append(json_data_kari)
    return json_data


def get_index_text():
    text_name = './link_data/index_name.tsv'
    index_textnum_data = {}
    with open(text_name, 'r') as f:
        for line in f:
            line = line.strip().split('\t')
            if len(line) != 5 or line[2] != 'C':
                continue

            name = line[4].split('/')[-1]
            name = int(name.split('.')[0])
            origin = line[2] + line[0]
            index_textnum_data.update({origin: name})

    return index_textnum_data


def get_weigh():
    graph_weigt_list = [defaultdict(int), defaultdict(int)]

    for mode_ind, mode in enumerate(['case', 'status']):
        text_name = './link_data/{}_notice_ref.tsv'.format(mode)
        with open(text_name, 'r') as f:
            lines = f.read().strip().split('\n')
        for i, line in enumerate(lines):
            line = line.strip().split('\t')
            graph_weigt_list[mode_ind][line[0]] = len(line) - 1
    # print(graph_weigt_list)
    return graph_weigt_list

def get_link_data(json_data_list, index_textnum_data, value_limit_lis):
    link_data = defaultdict(set)
    # graph_weigt_list = get_weigh()

    for aaa, json_data in enumerate(json_data_list):
        for i in range(len(json_data)):
            node1, node2, value = json_data[i]
            # value = value / (graph_weigt_list[aaa][node1] + graph_weigt_list[aaa][node2])
            if float(value) < value_limit_lis[aaa]:
                continue
            if node1 in index_textnum_data and node2 in index_textnum_data:
                node1_ind = index_textnum_data[node1]
                node2_ind = index_textnum_data[node2]
                link_data[node1_ind].add(node2_ind - 1)
                link_data[node2_ind].add(node1_ind - 1)
    return link_data


def write_data(link_data):
    out_name = './corpus_data/link_data_all_co.txt'
    # max_num = max(list(link_data.keys()))

    with open(out_name, 'w') as out:
        for i in range(1, 6155):
            if i in link_data:
                now_data = list(map(str, link_data[i]))
                out.write('{}\n'.format(' '.join(now_data)))
            else:
                out.write('\n')

    out_name = './corpus_data/link_data_summary_co.txt'
    # max_num = max(list(link_data.keys()))
    with open(out_name, 'w') as out:
        for i in range(1, 6155):
            if i in link_data:
                now_data = list(map(str, link_data[i]))
                out.write('{}\n'.format(' '.join(now_data)))
            else:
                out.write('\n')


def main():
    # これ以上のもののみを入れる
    value_limit_lis = [0 , 0]
    data_name = 'both'
    # both, case. status
    data_mode = 'change'
    # 'origin', 'cahnge'

    json_data = get_json(data_name, data_mode)
    index_textnum_data = get_index_text()
    link_data = get_link_data(json_data, index_textnum_data, value_limit_lis)
    write_data(link_data)



if __name__ == '__main__':
    main()