import os
from pprint import pprint
# import snowballstemmer
from collections import defaultdict
from nltk.stem.porter import PorterStemmer as PS
import sys

stemmer = PS()



def ex_word(word, stop_list):
    word = word.replace(',', '')
    word = word.replace('.', '')
    word = word.lower()
    if ')' in word or '(' in word:
        word = ''
    if '[' in word or ']' in word:
        word = ''
    if word in stop_list:
        word = ''
    if word.isdigit():
        word = ''
    if len(word) <= 2:
        word = ''
    word = stemmer.stem(word)
    for ele in word:
        if ord(ele) > 122:
            word = ''
            break

    return word

def get_sent(text_name, docs, stop_list):
    with open(text_name, 'r', encoding='utf8', errors='ignore') as f:
        line_all = []
        for line in f:
            line = line.strip().split()
            for i, word in enumerate(line):
                word = ex_word(word, stop_list)
                line[i] = word
            line_all += line
    line_all = ' '.join(line_all)
    line_all = line_all.strip()
    docs.append(line_all)
    return docs




def get_stop():
    text_name = '../stop_word_list.txt'
    with open(text_name, 'r') as f:
        stop_word_list = [line.strip() for line in f]
    stop_word_list = set(stop_word_list)
    return stop_word_list

def get_docs(corpus):
    stop_list = get_stop()
    docs = []
    if corpus == 'all':
        path, dirs, files = next(os.walk('../../IR/data_concat/'))
    elif corpus == 'summary':
        path, dirs, files = next(os.walk('../../IR/data_summary_concat/'))
    file_list = sorted(files)
    print(len(file_list), 'is all num')
    for i, file_name in enumerate(file_list):
        text_name = path + "{}".format(file_name)
        docs = get_sent(text_name, docs, stop_list)
        if i % 100 == 0:
            print(i)
    return docs

count_vocab = 0
def get_vocab(docs):
    # docs = get_docs()
    global count_vocab
    vocab2ind = {}

    # pprint(docs)
    for i in range(len(docs)):
        for word in docs[i].split():
            word = word.replace("\"", "")
            if word in vocab2ind:
                continue
            vocab2ind.update({word : count_vocab})
            count_vocab += 1
    return vocab2ind

def make_apper_data(vocab2ind, docs, corpus):
    apper_name = 'corpus_data/doc_ids_{}.txt'.format(corpus)
    count_name = 'corpus_data/doc_cnt_{}.txt'.format(corpus)
    index2word_name = 'corpus_data/index2word_{}.txt'.format(corpus)

    with open(index2word_name, 'w') as out:
        for word, ind in vocab2ind.items():
            out.write('{}\t{}\n'.format(ind, word))

    with open(apper_name, 'w') as out_apper, open(count_name, 'w') as out_count:


        # pprint()

        for i, sent in enumerate(docs):
            apper_list = []
            count_dic = defaultdict(int)
            for word in sent.split():
                # print(word)
                word = word.replace("\"", "")
                ind = vocab2ind[word]
                # print(word, ind)
                if ind in apper_list:
                    count_dic[ind] += 1
                else:
                    apper_list.append(ind)
                    count_dic[ind] += 1

            # print(apper_list)
            # print(count_dic)

            if len(apper_list) == 0:
                out_apper.write('\n')
                out_count.write('\n')
            else:
                for i, ele in enumerate(apper_list):

                    out_apper.write(str(ele))
                    out_count.write(str(count_dic[ele]))
                    if i == len(apper_list) - 1:
                        out_apper.write('\n')
                        out_count.write('\n')
                    else:
                        out_apper.write(' ')
                        out_count.write(' ')



def check(corpus):

    if corpus == 'all':
        path, dirs, files = next(os.walk('../../IR/data_concat/'))
    elif corpus == 'summary':
        path, dirs, files = next(os.walk('../../IR/data_summary_concat/'))
    file_list = sorted(files)
    print(len(file_list), 'is all num')
    data_dic = set()
    for i, file_name in enumerate(file_list):
        ind = file_name.split('.')[0]
        data_dic.add(int(ind))

    for i in range(6156):
        if i not in data_dic:
            print(i)


def main():

    # corpus = 'summary'
    corpus = 'all'
    print(corpus)

    # check(corpus)
    # sys.exit()

    docs = get_docs(corpus)
    print(len(docs))
    vocab2ind = get_vocab(docs)
    make_apper_data(vocab2ind, docs, corpus)

if __name__ == '__main__':
    main()