import pickle
import logging
import sys, os
import numpy as np
import matplotlib
import matplotlib.pyplot as plt

from ptm.lda_vb import vbLDA
from ptm.utils import convert_cnt_to_list, get_top_words
# import tqdm
from evaluation import LoadModel, calc_cohe
def get_data(corpus, aft):
    path_name = './corpus_data/'

    doc_ids = []
    text_name = path_name + 'doc_ids_{}.txt'.format(corpus)
    with open(text_name, 'r') as f:
        for line in f:
            line = line.strip().split()
            line = list(map(int, line))
            doc_ids.append(line)

    doc_cnt = []
    text_name = path_name + 'doc_cnt_{}.txt'.format(corpus)
    with open(text_name, 'r') as f:
        for line in f:
            line = line.strip().split()
            line = list(map(int, line))
            doc_cnt.append(line)

    index2word = {}
    voca = []
    text_name = path_name + 'index2word_{}.txt'.format(corpus)
    with open(text_name, 'r') as f:
        for line in f:
            line = line.strip().split('\t')
            if len(line) == 1:
                voca.append('')
                continue
            ind, word = line[0], line[1]
            voca.append(word)
            index2word.update({ind : word})

    return doc_ids, doc_cnt, voca, index2word
from gensim.corpora import Dictionary
from gensim.models import LdaModel
def gensim_lda(docs,n_topic,max_iter):
    # Create a dictionary representation of the documents.
    dictionary = Dictionary(docs)
    # Filter out words that occur less than 20 documents, or more than 50% of the documents.
    # dictionary.filter_extremes(no_below=20, no_above=0.5)
    # Train LDA model.
    # Set training parameters.
    # chunksize = 2000
    # passes = 20
    eval_every = None  # Don't evaluate model perplexity, takes too much time.
    # Make a index to word dictionary.
    temp = dictionary[0]  # This is only to "load" the dictionary.
    id2word = dictionary.id2token
    corpus = [dictionary.doc2bow(doc) for doc in docs]
    model = LdaModel(
        corpus=corpus,
        id2word=id2word,
        alpha='auto',
        eta='auto',
        iterations=max_iter,
        num_topics=n_topic,
        eval_every=eval_every
    )
    return model

def make_dir(corpus):
    try:
        os.mkdir('./{}/'.format(corpus))
    except:
        print('folder is already existing.')
def get_docs(doc_ids,index2word):
    return [[index2word[str(i)]for i in doc]for doc in doc_ids]

def main():
    # logging.basicConfig(filename='example.log',level=logging.DEBUG)
    # logger.propagate=False

    # %matplotlib inline

    # doc_ids = pickle.load(open('./python-topic-model/data/cora/doc_ids.pkl', 'rb'))
    # doc_cnt = pickle.load(open('./python-topic-model//data/cora/doc_cnt.pkl', 'rb'))
    # doc_links = pickle.load(open('./python-topic-model//data/cora/doc_links_sym.pkl', 'rb'))
    # voca = pickle.load(open('./python-topic-model//data/cora/voca.pkl', 'rb'))

    corpus = 'all'
    path_data = 'lda'
    max_iter = 10
    journal_mode = 0


    make_dir(corpus)
    make_dir('output/{}'.format(path_data))
    aft = '_co'

    doc_ids, doc_cnt, voca, index2word = get_data(corpus, aft)
    docs=get_docs(doc_ids,index2word)
    data_name = corpus
    
   
    embedding_name = '/mnt/nfs/nas4/cicoda_tmp/cicoda_tmp/Osaka/data/glove.840B.300d.txt'
    
    # print('Loading glove model...')
    # glove = LoadModel(embedding_name)
    if len(sys.argv)>1:num_lis=[int(sys.argv[1])]
    else:num_lis=[10, 50, 100,200]
    for n_topic in num_lis:
        # aaa = 10
        n_doc = len(doc_ids)
        # n_topic = aaa
        n_voca = len(voca)
        value_lim = '5'


        print('doc_isd len is', len(doc_ids))
        print('doc_cnt len is', len(doc_cnt))
        print('voca len is', len(voca))
        # coh=[]
        # for i in range(10):
        # model = vbLDA(n_doc, n_voca, n_topic,verbose=False,is_compute_bound=False)
        # model.fit(doc_ids, doc_cnt,max_iter=max_iter)
        # model.save_model(data_name)

        model =gensim_lda(docs,n_topic,max_iter)
        top_words=model.show_topics(num_topics=n_topic , num_words=10,formatted=False)
        out_name = '{}.txt'.format(data_name)
        path = './output/{}/{}{}'.format(path_data, str(n_topic), out_name)
        # path = './output/' + path_data + ws + str(n_topic) + out_name
        with open(path, 'w') as out:
            for ti in range(n_topic):
                word_ti =[w[0] for w in top_words[ti][1]]
                out.write('{}\t{}\n'.format(ti, '\t'.join(word_ti)))

        # sys.exit()
        # coh+=[calc_cohe(path, glove)]
        # print('Avg:{}, std:{}'.format(sum(coh),np.std(coh)))


if __name__ == '__main__':
    main()

