
import os
from collections import defaultdict
from pprint import pprint
import re

def add_ind_dic(index_dic, name, phrase):
    if name in index_dic.keys():
        pass
    elif len(name) < 2:
        pass
    else:
        year_inf = get_year_inf(name)
        index_dic.update({name : [len(index_dic), year_inf, phrase[0]]})
    return index_dic

def update_dic(data, original_text, index_dic, now_dic):
    now_dic[index_dic[original_text][0]].append(index_dic[data])
    return now_dic

def get_data_name(line, phrase):

    if phrase == 'Cases Noticed:':
        count = 0
        index = -1
        for i, char in enumerate(list(line)):
            if char.isdigit():
                count += 1
            else:
                count = 0
            if count == 4:
                index = i + 2
                break
        if index == -1:
            data = line
        else:
            data = line[:index]
    elif phrase == 'Statutes Noticed:':
        data = line.split(',')[0]
    # print(data)
    return data


def add_data(lines, phrase, index_dic, now_dic, original_text):
    for line_data in lines:
        line_data = line_data.strip().split('\n\n')
        # print(line_data)
        # input()
        if line_data[0] == phrase:
            # input()
            # print('yyy')
            # print(line_data)
            # print(line_data[0])
            for line in line_data[1:]:
                # print(line)
                line = line.strip().replace('\t', ' ')
                line = line.replace('\n', ' ')
                # data = []
                data = get_data_name(line, phrase)

                if len(data) < 2:
                    # print('ttttttt')
                    pass
                else:
                    # print('ttt')
                    index_dic = add_ind_dic(index_dic, data, phrase)
                    now_dic = update_dic(data, original_text, index_dic, now_dic)

    return now_dic, index_dic

def get_text_dic_name(text_name):
    with open(text_name, 'r', encoding='utf8', errors='ignore') as f:
        lines = f.read().strip().split('\n\n\n\n')

    count = 0
    # print(line)
    flg = 1
    # print(lines)
    for i in range(3):
        line = lines[i].strip().replace('\t', ' ')
        for i, char in enumerate(list(line)):
            if char.isdigit():
                count += 1
            else:
                count = 0
            if count == 4:
                if i == len(line) - 1:
                    pass
                elif line[i + 1].isdigit() or line[i + 1] == '-':
                    count = 0
                    continue
                text_dic_name = line[:i + 2]
                # text_year = line[i - 4: i]
                flg = 0
                break
        if not flg:
            break
    if flg:
        text_dic_name = line
    # print(text_dic_name)
    text_dic_name = text_dic_name.replace('\n', '')

    return text_dic_name

def get_year_inf(line):
    flg = 1
    count = 0
    for i, char in enumerate(list(line)):
        if char.isdigit():
            count += 1
        else:
            count = 0
        if count == 4:
            # print(line)
            if i == len(line) - 1:
                pass
            elif line[i + 1].isdigit() or line[i + 1] == '-':
                count = 0
                continue
            year = line[i - 3:i + 1]
            # text_year = line[i - 4: i]
            flg = 0
            break
    if flg:
        year = 'xxxx'
    return year


def collect_data(case_notice_dic, status_notice_dic, index_dic, text_name):
    # text_dic_name = text_name.split('/', 3)[-1]
    text_dic_name = get_text_dic_name(text_name)
    text_dic_name = text_name




    if text_dic_name not in index_dic:
        # if text_dic_name == 'Brar v. Can. (1989)':
        #     print(text_name)

        index_dic = add_ind_dic(index_dic, text_dic_name, 'Cases Noticed:')
        with open(text_name, 'r', encoding='utf8') as f:
            lines = f.read().strip().split('\n\n\n\n')


        case_notice_dic, index_dic = add_data(lines, 'Cases Noticed:', index_dic, case_notice_dic, text_dic_name)
        status_notice_dic, index_dic = add_data(lines, 'Statutes Noticed:', index_dic, status_notice_dic, text_dic_name)

    return case_notice_dic, status_notice_dic, index_dic

def get_index_name(index_dic):
    index_name_dic = {}
    for name, list_data in index_dic.items():
        num, year, c_or_s = list_data
        index_name_dic.update({num : [name, year, c_or_s]})
    return index_name_dic

def write_index(index_dic):
    index_name_dic = get_index_name(index_dic)
    out_name = './link_data/index_name.tsv'
    with open(out_name, 'w', encoding='utf8') as out:
        for i in range(len(index_name_dic)):
            name, year, c_or_s = index_name_dic[i]
            out.write('{}\t{}\t{}\t{}\n'.format(i, year, c_or_s, name))

def write_data_ref(now_dic, mode, index_dic_data):
    out_name = './link_data/{}_ref.tsv'.format(mode)
    with open(out_name, 'w', encoding='utf8') as out:
        for key, value in now_dic.items():
            # print(key)
            # print(value)
            num_data = [index_dic_data[value[i][0]] for i in range(len(value))]
            key = index_dic_data[key]
            out.write('{}\t{}\n'.format(key, '\t'.join(list(map(str, num_data)))))


def get_index_dic_data():
    text_name = './link_data/index_name.tsv'
    index_dic_data = {}
    with open(text_name, 'r', encoding='utf8') as f:
        lines = f.read().strip().split('\n')
    for i, line in enumerate(lines):
        line = line.strip().split('\t')
        try:
            index_dic_data.update({int(line[0]) : '{}{}'.format(line[2], line[0])})
        except:
            print('---')
            print(i)
            print(line)
            print('---')
            input()
            print(line[0])
            print(line[2])
            input()
    return index_dic_data


def write_data_notice(index_dic_data):
    final_dic = defaultdict(list)
    text_name = './link_data/case_notice_ref.tsv'

    with open(text_name, 'r', encoding='utf8') as f:
        for line in f:
            line = line.strip().split('\t')
            for ele in line[1:]:
                final_dic[line[0]].append(ele)
    text_name = './link_data/status_notice_ref.tsv'
    with open(text_name, 'r', encoding='utf8') as f:
        for line in f:
            line = line.strip().split('\t')
            for ele in line[1:]:
                final_dic[line[0]].append(ele)

    out_name = './link_data/notice_ref.tsv'
    with open(out_name, 'w') as out:
        for key, value in final_dic.items():
            out.write('{}\t{}\n'.format(key, '\t'.join(value)))


def write_data(index_dic, case_notice_dic, status_notice_dic):
    write_index(index_dic)
    index_dic_data = get_index_dic_data()
    write_data_ref(case_notice_dic, 'case_notice', index_dic_data)
    write_data_ref(status_notice_dic, 'status_notice', index_dic_data)
    write_data_notice(index_dic_data)

def start_process():
    case_notice_dic = defaultdict(list)
    status_notice_dic = defaultdict(list)
    index_dic = {}

    path, dirs, files = next(os.walk("../../IR/data_concat/"))
    file_list = sorted(files)

    for i, file_data in enumerate(file_list):
        text_name = "{}{}".format(path, file_data)
        # print(text_name)
        case_notice_dic, status_notice_dic, index_dic = collect_data(case_notice_dic, status_notice_dic, index_dic,
                                                                     text_name)
        # if i == 0:
        #     break
        if i % 5000 == 0:
            print('{}/{}'.format(i, len(file_list)))

    write_data(index_dic, case_notice_dic, status_notice_dic)



def main():
    start_process()

if __name__ == '__main__':
    main()