
from collections import defaultdict

def get_max_num():
    global corpus
    text_name = './corpus_data/doc_cnt_{}.txt'.format(corpus)
    with open(text_name, 'r') as f:
        lines = f.read().strip().split('\n')
    return len(lines)


def get_link():
    global corpus
    max_num = get_max_num()
    final_link_data = defaultdict(set)

    text_name = './link_data/link_data_{}.txt'.format(corpus)
    with open(text_name, 'r') as f:
        for line in f:
            line = line.strip().split()
            data = list(map(int, line))

            for ele in data[1:]:
                final_link_data[ele].add(data[0])
                final_link_data[data[0]].add(ele)
    return final_link_data, max_num

def get_name():
    entry_name_dic = {}
    entry_name_dic_rev = {}
    text_name = './link_data/index_name.tsv'
    with open(text_name, 'r') as f:
        for line in f:
            line = line.strip().split('\t')
            entry = line[3].split('/')
            if len(entry) != 5:
                continue
            data = entry[4].replace('.txt', '')
            entry_name_dic.update({int(data) : int(line[0])})
            entry_name_dic_rev.update({int(line[0]) : int(data)})

    return entry_name_dic, entry_name_dic_rev

corpus = ''

def main():
    global corpus
    corpus = 'all'
    link_data_list = []

    text_name = './link_data/case_notice_ref.tsv'
    with open(text_name, 'r') as f:
        for line in f:
            kari_data = []
            line = line.strip().split('\t')
            for ele in line:
                if ele[0] == 'S':
                    continue
                kari_data.append(ele[1:])
            link_data_list.append(kari_data)

    out_name = './link_data/link_data_{}.txt'.format(corpus)
    with open(out_name, 'w') as out:
        for ele in link_data_list:
            out.write(' '.join(ele) + '\n')

    final_link_data, max_num = get_link()

    entry_name_dic, entry_name_dic_rev = get_name()

    print(entry_name_dic)
    print(entry_name_dic_rev)
    print(len(entry_name_dic_rev))

    out_name = './corpus_data/link_data_{}.txt'.format(corpus)
    with open(out_name, 'w') as out:
        for i in range(max_num):
            if i not in entry_name_dic:
                out.write('')
            else:
                num = entry_name_dic[i]
                add_set = set()
                data = final_link_data[num]

                for ele in data:
                    if ele not in entry_name_dic_rev:
                        continue
                    aaa = entry_name_dic_rev[ele]

                    if aaa == num:
                        continue
                    add_set.add(aaa)


                add_list = list(map(str, list(add_set)))
                out.write(' '.join(add_list) + '\n')



if __name__ == '__main__':
    main()